<template>
  <view class="page-raw-receipt">
    <view class="top"></view>
    <view class="header">
      <view class="left">
        <u-icon class="icon" name="arrow-left" @click="uni.navigateBack()" />
      </view>
      <view class="title">{{ $t('message.FillingMaterials') }}</view>
      <view class="right"></view>
    </view>
    <view class="content">
      <!-- 单号 -->
      <view class="single">
        <view class="single-left">
          <view>{{ $t('message.InventoryOrderNo') }}:</view>
          <u-search :placeholder="$t('message.InventoryPleaseScan')" v-model="form.documentNo" @search="query" :show-action="false"></u-search>
        </view>
        <view class="single-right">
          <u-button type="primary" @click="query">{{ $t('message.Query') }}</u-button>
        </view>
      </view>
      <!-- 物料 -->
      <view class="material">
        <view class="material-left">
          <view>{{ $t('message.CommissionedMaterielNo') }}:</view>
          <jPicker sureColor="#ff0000" style="width: 260rpx" @bindpicker="materialChoice" showKey="value" valKey="value" :val="some.materialCode" class="search" :options="materialList" />
        </view>
      </view>
      <view class="material">
        <view class="material-right">
          <view class="material-right-title">{{ $t('message.CommissionedMaterielDesc') }}:</view>
          <view class="material-right-code" style="overflow: hidden">{{ some.materialDesc }}</view>
        </view>
      </view>
      <view class="material">
        <view class="material-right">
          <view class="material-right-title">{{ $t('message.Feeding_ReplenishedQuantity') }}:</view>
          <view class="material-right-code" style="overflow: hidden">{{ some.totalFillAmount }}</view>
        </view>
      </view>
      <view class="material">
        <view class="material-right">
          <view class="material-right-title">{{ $t('message.Replenishment_Number') }}:</view>
          <view class="material-right-code" style="overflow: hidden">{{ some.amount }}</view>
        </view>
      </view>
      <!-- 列表展示数据 -->
      <view class="number">
        <view class="number-left">
          <view class="number-left-title">{{ $t('message.Pi_Station') }}:</view>
          <u-input v-model="some.sendSpot" placeholder=" " :type="type" :border="border" class="input" disabled  style="padding:'0';"/>
        </view>
        <view class="number-right">
          <view class="number-right-title">{{ $t('message.total') }}:</view>
          <u-input placeholder=" " v-model="some.fillAmount" :type="type" :border="border" class="input" style="padding:'0';" disabled />
        </view>
      </view>
      <!-- 库位 -->
      <view class="library">
        <view class="library-left">
          <view>{{ $t('message.CommissionedLocation') }}:</view>
          <jPicker sureColor="#ff0000" style="width: 230rpx" @bindpicker="LocationChoice" showKey="value" valKey="value" :val="wlCode.value" class="search" :options="Location" />
        </view>
        <view class="library-right">
          <view class="library-right-title">{{ $t('message.CommissionedThisNumber') }}:</view>
          <u-input :placeholder="$t('message.po_PleaseInput')" v-model="qty" type="number" :border="border" class="input" />
        </view>
      </view>
      <!-- 添加 -->
      <view class="add">
        <u-button type="primary" @click="Add">{{ $t('message.product_add') }}</u-button>
      </view>
      <!-- 表格 -->
      <wyb-table class="table" ref="table" width="100%" show-left-and-right-border :headers="detailHeader" :contents="LocationList" :show-vert-border="false" @onCellClick="deleteItem($event)"></wyb-table>
    </view>
    <view class="bottom-bar">
      <div class="extra">
        <u-form ref="form" :model="form" :error-type="['toast']">
          <u-row class="bottom-info"> </u-row>
        </u-form>
      </div>
      <u-form ref="form2" :model="form2" :error-type="['toast']" style="background: rgb(255, 255, 255)">
        <u-row class="bottom-info">
          <u-col :span="6">
            <u-form-item prop="operatorPass" :label="$t('message.Summary_Receiver')" label-width="120rpx">
              <u-input v-model="operatorName" @confirm="onOperatorConfirm" :placeholder="$t('message.po_PleaseInput')" />
            </u-form-item>
          </u-col>
          <u-col :span="6">
            <u-form-item prop="rfPwd" :label="$t('message.Summary_Password')">
              <u-input v-model="form2.rfPwd" type="password" :placeholder="$t('message.po_PleaseInput')" />
            </u-form-item>
          </u-col>
        </u-row>
      </u-form>
      <div class="container">
        <u-row>
          <u-col :span="4">
            <u-button type="primary" class="appoint" @click="bill">{{ $t('message.Feeding_ReplenishmentDetails') }}</u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="success" @click="onSubmit">
              {{ $t('message.product_Upload') }}
            </u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="error" @click="uni.navigateBack()">
              {{ $t('message.po_Return') }}
            </u-button>
          </u-col>
        </u-row>
      </div>
    </view>
  </view>
</template>

<script lang="ts">
import { Component, Ref } from 'vue-property-decorator';
import { BasePage } from '@/components/base/page';
import model from './model';
import { session } from '@/store/modules/session';
import { VForm, VFormRules } from 'vue/types/form';
import jPicker from '@/components/J-Picker/jPicker.vue';
import {  detailHeader } from './config';
import { auth } from '@/store/modules/auth';
@Component({
  components: {
    jPicker,
  },
})
export default class RawReceiptDetail extends BasePage {
  /**
   * 表单引用
   */
  @Ref('form') readonly $form!: VForm;
  @Ref('submitForm') readonly $submitForm!: VForm;
  @Ref('form2') readonly $form2!: VForm;
  submitForm = {
    receiver: '',
    receiverName: '',
    password: '',
  };
  /**
   * 页面Module
   */
  model = model;
  materialList:any = []
  type = 'text';
  wlCode: any = '';
  border = true;
  operatorName = '';
  //添加库位和数量的列表
  LocationList: any = [];
  gather: any = [];
  //库位
  Location: any = [];
  someIndex: number = 0;
  some: any = {};
  qty: any = '';
  /**
   * 表单数据
   */
  form: any = {
    documentNo:'',
    amount: null,
  };
  form2 = {
    operatorPass: '', // 接收人
    rfPwd:''
  };
  /**
   * 表单校验
   */
  rules: VFormRules<any> = {
    amount: [{ required: true, message: this.$t('message.Pi_tip1') as string }],
  };

  /**
   * 库存地点选择
   */
  locationCodeSelect = false;
  detailHeader = detailHeader;
  empty(){
    this.some = {}
    this.someIndex = 0
    this.qty = ''
    this.Location = []
    this.wlCode = ''
    this.materialList = []
    this.model.blDetailList.length = 0
  }
  async query(){
    if(this.form.documentNo == ''){
      this.customToast(this.$t('message.Commission_tips1') as string);
    }
    this.empty()
    let inPrdOrderList = this.form.documentNo.split(",")
    let params = {
      inPrdOrderList
    }
    await await this.model.queryBlDetailList(params).then(() =>{
      this.model.blDetailList.forEach((item:any) =>{
        let arr = {
          label:item.materialCode,
          value:item.materialCode,
        }
        this.materialList.push(arr)
        item.wlList = []
      })
      this.some = this.model.blDetailList[0];
      this.someIndex = 0
    })
  }
  materialChoice(e:any){
    this.model.blDetailList.forEach((item:any,index:any) =>{
      if(item.materialCode == e.pickerName.label){
        this.some = item
        this.someIndex = index
      }
    })
    this.qty = '';
  }
  LocationChoice(e: any) {
    this.wlCode = e.pickerName;
  }
  async onOperatorConfirm(loginName: string) {
    try {
      const { userName } = await auth.getUserInfo({ loginName });
      this.form2.operatorPass = loginName;
      this.operatorName = userName;
    } catch {
      this.form2.operatorPass = '';
      this.operatorName = '';
    }
  }
  Add() {
    if (this.qty == '' || this.wlCode == '') {
      // uni.showToast({
      //   icon: 'none',
      //   title: this.$t('message.AppendMateriel1') as string,
      // });
      this.customToast(this.$t('message.AppendMateriel1') as string);
      return;
    }
    if (parseFloat(this.qty) <= 0) {
      // uni.showToast({
      //   icon: 'none',
      //   title: this.$t('message.AppendMateriel2') as string,
      // });
      this.customToast(this.$t('message.AppendMateriel2') as string);
      return;
    }
    if (parseFloat(this.qty) > model.blDetailList[this.someIndex].amount) {
      // uni.showToast({
      //   icon: 'none',
      //   title: this.$t('message.AppendMateriel3') as string,
      // });
      this.customToast(this.$t('message.AppendMateriel3') as string);
      return;
    }
    let num = parseFloat(this.qty);
    this.model.blDetailList[this.someIndex].wlList.forEach((item: any) => {
      num += parseFloat(item.qty);
    });
    if (num > this.model.blDetailList[this.someIndex].amount) {
      // uni.showToast({
      //   icon: 'none',
      //   title: this.$t('message.AppendMateriel3') as string,
      // });
      this.customToast(this.$t('message.AppendMateriel3') as string);
      return;
    }
    let isTrue: boolean = true;
    if (this.LocationList.length != 0) {
      this.model.blDetailList[this.someIndex].wlList.forEach((item: any) => {
        if (this.wlCode.sendSpot != item.Code) {
          // uni.showToast({
          //   icon: 'none',
          //   title: this.$t('message.AppendMateriel4') as string,
          // });
          this.customToast(this.$t('message.AppendMateriel4') as string);
          return (isTrue = false);
        }
      });
    }
    if (this.some == {}) {
      // uni.showToast({
      //   icon: 'none',
      //   title: this.$t('message.AppendMateriel5') as string,
      // });
      this.customToast(this.$t('message.AppendMateriel5') as string);
      return;
    }
    if (isTrue == true) {
      let arr = {
        wlCode: this.wlCode.label,
        qty: this.qty,
        Code: this.wlCode.sendSpot,
        ...this.some,
      };
      this.LocationList.push(arr);
      this.model.blDetailList[this.someIndex].wlList.push(arr);
      this.qty = '';
      this.business();
    }
  }
  deleteItem(e: any) {
    uni.showModal({
      content: this.$t('message.product_Delete') as string,
      cancelText: this.$t('message.Cancel') as string,
      confirmText: this.$t('message.workArea_Confirm') as string,
      success: (res) => {
        if (res.confirm) {
          let lineData = e.lineData;
          let i: any;
          this.model.blDetailList.forEach((item: any, index: any) => {
            if (item.materialCode == lineData.materialCode && item.sendSpot == lineData.sendSpot) {
              i = index;
            }
          });
          let NextIndex: any;
          this.model.blDetailList[i].wlList.forEach((item: any, index: any) => {
            if (item.wlCode == lineData.wlCode && item.qty == lineData.qty) {
              NextIndex = index;
            }
          });
          this.model.blDetailList[i].wlList.splice(NextIndex, 1);
          this.LocationList.splice(e.contentIndex, 1);
          let num: any = 0;
          this.model.blDetailList[i].wlList.forEach((item: any) => {
            num += parseFloat(item.qty);
          });
          this.model.blDetailList[i].fillAmount = num;
          console.log('this.model.blDetailList',this.model.blDetailList)
        } else if (res.cancel) {
          return;
        }
      },
    });
  }
  business() {
    let num: number = 0;
    this.model.blDetailList[this.someIndex].wlList.forEach((item: any) => {
      num += parseFloat(item.qty);
    });
    this.model.blDetailList[this.someIndex].fillAmount = num;
    this.some.fillAmount = num
    console.log('this.model.blDetailList',this.model.blDetailList)
  }
  async onReady() {
    let sendSpot = JSON.parse(localStorage.getItem('sendSpot') as any);
    let content = {
      loginName: session.loginName,
      sendSpot: sendSpot,
      factoryCode: session.factoryCode,
      workArea: session.workareaCode,
    };
    let res: any = await this.model.queryByFactoryCodeAndWorkAreaCode(content);
    console.log('res>>>>>>>>>>>>>>>>>>>>>>',res)
    res.forEach((item: any) => {
      let pickerName: any = {};
      pickerName.label = item.locationCode;
      pickerName.value = item.locationCode + '(' + item.sendSpot + ')';
      pickerName.sendSpot = item.sendSpot;
      this.Location.push(pickerName);
    });
    this.model.blDetailList.forEach((item: any) => {
      item.receiptAmount = 0;
      item.wlQTyList = [];
    });
    this.model.blDetailList.length = 0
    this.wlCode = this.Location[0]
  }
  async bill() {
    if (this.some == {} || this.some.prdOrder == null) {
      // uni.showToast({
      //   icon: 'none',
      //   title: this.$t('message.Commission_tips6') as string,
      // });
      this.customToast(this.$t('message.Commission_tips6') as string);
      return;
    }
    let person = JSON.parse(localStorage.getItem('__GWMS_APP_STATE_DATA__') as any);
    let content = {
      loginName: person.session.user.loginName,
      prdOrder: this.some.prdOrder,
    };
    await this.model.querydetaildlist(content);
    this.redirectTo(this.page.raw.handover.feeding.Local);
  }
  async onSubmit() {
    this.model.blDetailList.forEach((item:any) =>{
      item.wlList.forEach((item:any) =>{
        item.wlList = null
      })
    })
    let dataList = this.model.blDetailList;
    const params = {
      dataList,
      ...this.form2,
      factoryCode: this.session.factoryCode,
      loginName: this.session.loginName,
    };
    await this.model.saveBlDetailUpload(params).then(() =>{
      this.qty = '';
      this.LocationList = []
      this.query()
    })
  }
}
</script>

<style lang="scss" scoped>
.page-raw-receipt {
  background: #f2f2f2 linear-gradient(0deg, #f2f2f2 0%, #4a78ea 51%, #1753ea 100%) no-repeat;
  background-size: 100% 600rpx;
  padding: 118rpx 30rpx 162rpx;
  min-height: 100%;
  .header {
    position: fixed;
    top: 36rpx;
    left: 0;
    right: 0;
    z-index: 99;
    display: flex;
    height: 88rpx;
    line-height: 88rpx;
    color: #fff;
    font-size: 34rpx;
    font-weight: 500;
    text-align: center;
    .title {
      flex: 3;
    }
    .left,
    .right {
      flex: 1;
    }
    .icon {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 88rpx;
      height: 88rpx;
    }
  }
  .content {
    width: 100%;
    background: white;
    border-radius: 15rpx;
    padding: 10rpx;
    .single {
      width: 100%;
      height: 100rpx;
      display: flex;
      .single-left {
        width: 80%;
        height: 100%;
        display: flex;
        view {
          width: 110rpx;
          height: 100%;
          line-height: 100rpx;
        }
      }
      .single-right {
        button {
          margin-top: 15rpx;
          width: 150rpx;
          height: 70rpx;
        }
      }
    }
    .material {
      width: 100%;
      height: 100rpx;
      display: flex;
      .material-left {
        width: 100%;
        height: 100%;
        display: flex;
        view {
          width: 145rpx;
          line-height: 100rpx;
        }
        .search{
          padding-left: 12px;
        }
      }
    }
    .material {
      width: 100%;
      height: 100rpx;
      display: flex;
      .material-right {
        width: 100%;
        height: 100%;
        display: flex;
        .material-right-title {
          width: 145rpx;
          height: 100%;
          line-height: 100rpx;
        }
        .material-right-code {
          width: 80%;
          height: 100%;
          line-height: 100rpx;
          text-align: left;
          padding-left: 10px;
          // line-height: 100rpx;
        }
      }
    }
    .number {
      height: 100rpx;
      display: flex;
      .number-left {
        width: 50%;
        height: 100%;
        display: flex;
        .number-left-title {
          width: 120rpx;
          height: 100%;
          line-height: 100rpx;
        }
        .input {
          width: 200rpx;
          height: 70rpx;
          margin-top: 15rpx;
          margin-left: 15rpx;
        }
      }
      .number-right {
        width: 50%;
        height: 100%;
        display: flex;
        .number-right-title {
          width: 120rpx;
          height: 100%;
          line-height: 100rpx;
          text-align: center;
        }
        .input {
          width: 200rpx;
          height: 70rpx;
          margin-top: 15rpx;
          margin-left: 15rpx;
        }
      }
    }
    .library {
      width: 100%;
      height: 100rpx;
      display: flex;
      .library-left {
        width: 50%;
        height: 100%;
        display: flex;
        view {
          width: 100rpx;
          line-height: 100rpx;
        }
        .search {
          padding-left: 19px;
          text-align: left;
        }
      }
      .library-right {
        width: 50%;
        height: 100%;
        display: flex;
        .library-right-title {
          width: 120rpx;
          height: 100%;
          line-height: 100rpx;
          text-align: center;
        }
        .input {
          width: 200rpx;
          height: 70rpx;
          margin-top: 15rpx;
          margin-left: 15rpx;
        }
      }
    }
    .add {
      width: 100%;
      height: 100rpx;
      position: relative;
      button {
        position: absolute;
        top: 10rpx;
        right: 20rpx;
      }
    }
  }
  .bottom-bar {
    z-index: 21;
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;

    .container {
      background: #ffffff;
      // box-shadow: 0 1rpx 20rpx 0 rgba(128, 128, 128, 0.2);
      padding: 20rpx;
    }

    .extra {
      background-color: #fff;
      margin: 5px;
      border-radius: 5px;
      padding: 0 10px;
    }

    .bottom-info {
      .u-form-item {
        padding: 0;
      }
    }
  }
}
</style>
